'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _audio = require('./audio');

var _audio2 = _interopRequireDefault(_audio);

var _searchbox = require('./searchbox');

var _searchbox2 = _interopRequireDefault(_searchbox);

var _searchresults = require('./searchresults');

var _searchresults2 = _interopRequireDefault(_searchresults);

var _transcript = require('./transcript');

var _transcript2 = _interopRequireDefault(_transcript);

var _search = require('./search');

var search = _interopRequireWildcard(_search);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MIN_QUERY_LEN = 3;

var TranscriptPlayer = function (_React$Component) {
  (0, _inherits3.default)(TranscriptPlayer, _React$Component);

  function TranscriptPlayer(props) {
    (0, _classCallCheck3.default)(this, TranscriptPlayer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(TranscriptPlayer).call(this, props));

    _this.handleTimeUpdate = _this.handleTimeUpdate.bind(_this);
    _this.handleEnded = _this.handleEnded.bind(_this);
    _this.handlePause = _this.handlePause.bind(_this);
    _this.handlePlaying = _this.handlePlaying.bind(_this);
    _this.handleSeekRequest = _this.handleSeekRequest.bind(_this);
    _this.handleQuery = _this.handleQuery.bind(_this);
    _this.findNextResultTime = _this.findNextResultTime.bind(_this);
    _this.findPrevResultTime = _this.findPrevResultTime.bind(_this);
    _this.handleNavigateResult = _this.handleNavigateResult.bind(_this);
    _this.state = { time: 0,
      seekTime: props.seekTime,
      playing: false,
      ended: false,
      query: '',
      searchResults: null
    };
    return _this;
  }

  (0, _createClass3.default)(TranscriptPlayer, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ seekTime: nextProps.seekTime });
    }
  }, {
    key: 'handleTimeUpdate',
    value: function handleTimeUpdate(unrounded_time) {
      var time = Math.round(unrounded_time);
      if (this.props.onTimeUpdate && time !== this.state.time) {
        this.props.onTimeUpdate(time);
      }
      if (time === this.state.seekTime) {
        this.setState({ time: time, seekTime: null });
      } else {
        this.setState({ time: time });
      }
    }
  }, {
    key: 'handleEnded',
    value: function handleEnded(ended) {
      this.setState({ ended: ended });
    }
  }, {
    key: 'handlePause',
    value: function handlePause() {
      if (this.props.onPause) this.props.onPause();
    }
  }, {
    key: 'handlePlaying',
    value: function handlePlaying() {
      this.setState({ playing: true });
      if (this.props.onPlaying) this.props.onPlaying();
    }
  }, {
    key: 'handleSeekRequest',
    value: function handleSeekRequest(seekTime) {
      this.setState({ seekTime: seekTime, ended: false });
    }
  }, {
    key: 'handleQuery',
    value: function handleQuery(query) {
      if (query.length < MIN_QUERY_LEN) {
        this.setState({ query: query, searchResults: null });
      } else {
        var searchResults = search.execute(this.props.transcript.turns, new RegExp(query, 'ig'));
        var times = searchResults.get('times');
        if (times.size > 0) {
          this.setState({ query: query, searchResults: searchResults,
            seekTime: times.first(), playing: false, ended: false });
        } else {
          this.setState({ query: query, searchResults: searchResults });
        }
      }
    }
  }, {
    key: 'findNextResultTime',
    value: function findNextResultTime(searchResults) {
      var times = searchResults.get('times');
      var seekTime = times.first();
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(times.values()), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var time = _step.value;

          if (time > this.state.time) {
            seekTime = time;
            break;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return seekTime;
    }
  }, {
    key: 'findPrevResultTime',
    value: function findPrevResultTime(searchResults) {
      var times = searchResults.get('times');
      var seekTime = times.last();
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)(times.reverse().values()), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var time = _step2.value;

          if (time < this.state.time) {
            seekTime = time;
            break;
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return seekTime;
    }
  }, {
    key: 'handleNavigateResult',
    value: function handleNavigateResult(direction) {
      if (this.state.searchResults === null) return;
      if (this.state.searchResults.get('times').size == 0) return;
      this.handleSeekRequest(direction === 'forward' ? this.findNextResultTime(this.state.searchResults) : this.findPrevResultTime(this.state.searchResults));
    }
  }, {
    key: 'render',
    value: function render() {
      var searchResults = this.state.searchResults === null ? null : _react2.default.createElement(_searchresults2.default, {
        count: this.state.searchResults.get('times').size,
        onNavigateResult: this.handleNavigateResult
      });
      return _react2.default.createElement(
        'div',
        { className: 'flex flex-column' },
        _react2.default.createElement(_audio2.default, {
          media: this.props.transcript.media,
          onEnded: this.handleEnded,
          onPause: this.handlePause,
          onPlaying: this.handlePlaying,
          onTimeUpdate: this.handleTimeUpdate,
          play: this.state.playing,
          seekTime: this.state.seekTime
        }),
        _react2.default.createElement(
          'div',
          { className: 'clearfix p1 mb1' },
          _react2.default.createElement(_searchbox2.default, {
            onQuery: this.handleQuery,
            query: this.state.query
          }),
          searchResults
        ),
        _react2.default.createElement(_transcript2.default, {
          ended: this.state.ended,
          highlights: this.state.searchResults ? this.state.searchResults.get('matches') : (0, _immutable.Map)(),
          key: this.props.transcript.id,
          onSeekRequest: this.handleSeekRequest,
          speakers: this.props.transcript.speakers,
          time: this.state.time,
          turns: this.props.transcript.turns
        })
      );
    }
  }]);
  return TranscriptPlayer;
}(_react2.default.Component);

TranscriptPlayer.propTypes = { onPause: _react2.default.PropTypes.func,
  onPlaying: _react2.default.PropTypes.func,
  onTimeUpdate: _react2.default.PropTypes.func,
  play: _react2.default.PropTypes.bool,
  seekTime: _react2.default.PropTypes.number,
  transcript: _react2.default.PropTypes.shape({ id: _react2.default.PropTypes.string,
    media: _react2.default.PropTypes.string,
    speakers: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.string),
    turns: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.object)
  }).isRequired
};
TranscriptPlayer.defaultProps = { play: false, seekTime: null };
exports.default = TranscriptPlayer;