'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _immutable = require('immutable');

var _transcriptSpeech = require('./transcript-speech');

var _transcriptSpeech2 = _interopRequireDefault(_transcriptSpeech);

var _functify = require('./functify');

var _functify2 = _interopRequireDefault(_functify);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TurnView = function (_React$Component) {
  (0, _inherits3.default)(TurnView, _React$Component);

  function TurnView(props) {
    (0, _classCallCheck3.default)(this, TurnView);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(TurnView).call(this, props));
  }

  (0, _createClass3.default)(TurnView, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var el = _reactDom2.default.findDOMNode(this),
          p = el.parentNode,
          bottom = function bottom(el) {
        return el.offsetTop + el.offsetHeight;
      },
          displayable = function displayable() {
        return bottom(el) < bottom(p);
      };
      var status, end;
      if (displayable()) {
        status = 'ok';
        end = this.props.speech.slice(-1)[0].end;
      } else {
        var nodes = this.refs.speech.getElementsByClassName('speech'),
            i = nodes.length - 1;
        for (; i >= 0; i--) {
          nodes.item(i).style.display = 'none';
          if (displayable()) {
            break;
          }
        }
        if (i > 0) {
          status = 'truncated';
          end = this.props.speech[i - 1].end;
        } else {
          status = 'failed';
        }
      }
      this.props.onMounted(status, this.props.index, end);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var highlights = this.props.highlights.reduce(function (highlights, match) {
        match.entrySeq().forEach(function (_ref) {
          var _ref2 = (0, _slicedToArray3.default)(_ref, 2);

          var speech_idx = _ref2[0];
          var range = _ref2[1];

          highlights = highlights.update(speech_idx, (0, _immutable.List)(), function (ranges) {
            return ranges.push(range);
          });
        });
        return highlights;
      }, (0, _immutable.Map)());
      var speechViews = (0, _functify2.default)(this.props.speech).map(function (speech) {
        return [_react2.default.createElement(_transcriptSpeech2.default, {
          highlights: highlights.get(speech.index, (0, _immutable.List)()),
          onClick: _this2.props.onSpeechClick,
          progress: (0, _utils.progress)(_this2.props.time, speech.start, speech.end),
          start: speech.start,
          text: speech.text
        }), ' '];
      }).toArray();
      var className = 'turn ' + this.props.progress + ' p1';
      className += this.props.index % 2 ? ' bg-white' : ' bg-silver';
      return _react2.default.createElement(
        'div',
        {
          className: className,
          style: { transition: 'color 0.4s ease' }
        },
        _react2.default.createElement(
          'span',
          { className: 'bold mr1' },
          this.props.speaker
        ),
        _react2.default.createElement(
          'div',
          {
            className: 'inline',
            ref: 'speech'
          },
          speechViews
        )
      );
    }
  }]);
  return TurnView;
}(_react2.default.Component);

TurnView.propTypes = { highlights: _react2.default.PropTypes.instanceOf(_immutable.List),
  index: _react2.default.PropTypes.number.isRequired,
  onMounted: _react2.default.PropTypes.func.isRequired,
  onSpeechClick: _react2.default.PropTypes.func.isRequired,
  progress: _react2.default.PropTypes.string,
  sentences: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.string).isRequired,
  speaker: _react2.default.PropTypes.string.isRequired,
  speech: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.shape({ text: _react2.default.PropTypes.string,
    start: _react2.default.PropTypes.number,
    end: _react2.default.PropTypes.number
  })).isRequired,
  time: _react2.default.PropTypes.number.isRequired
};
TurnView.defaultProps = { highlights: (0, _immutable.List)(),
  progress: ''
};
exports.default = TurnView;